/**********************************************************************
Copyright (C) 2005 Mustek Corporation, All rights reserved
    
Filename: spicall_g.h   [Abstract: ]

Author: Jack            Date: 2005/05/13
	
Function Description:
	inform the global data
	
[Operative Environment:]

[Reference Articles:]

Revision History:
*********************************************************************/
/* sane - Scanner Access Now Easy.

   Copyright (C) 2005 Mustek.
   Originally maintained by Mustek
   Author:Roy 2005.5.24

   This file is part of the SANE package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   As a special exception, the authors of SANE give permission for
   additional uses of the libraries contained in this release of SANE.

   The exception is that, if you link a SANE library with other files
   to produce an executable, this does not by itself cause the
   resulting executable to be covered by the GNU General Public
   License.  Your use of that executable is in no way restricted on
   account of linking the SANE library code into it.

   This exception does not, however, invalidate any other reasons why
   the executable file might be covered by the GNU General Public
   License.

   If you submit changes to SANE to the maintainers to be included in
   a subsequent release, you agree by submitting the changes that
   those changes may be distributed with this exception intact.

   If you write modifications of your own for SANE, it is your choice
   whether to permit this exception to apply to your modifications.
   If you do not wish that, delete this exception notice.

*/
#ifndef _SPICALL_G_2005_5_13_
#define _SPICALL_G_2005_5_13_

#include <pthread.h>
#include "../include/typedef.h"
#include "ScannerDefine.h"

////////////////////////////////
//global variable
////////////////////////////////

//base type
BOOL g_bOpened;		//=FALSE;
BOOL g_bPrepared;	//=FALSE;
BOOL g_isCanceled;	//=FALSE;
BOOL g_bSharpen;	//=FALSE;
BOOL g_bFirstReadImage;
BOOL g_isScanning;
BOOL g_isSelfGamma;

BYTE g_bScanBits;
BYTE* g_lpReadImageHead;

WORD s_wOpticalYDpi[] = {1200, 600, 300, 150, 75, 0};
WORD s_wOpticalXDpi[] = {1200, 600, 300, 150, 75, 0};
WORD g_X;
WORD g_Y;
WORD g_Width;
WORD g_Height;
WORD g_XDpi;
WORD g_YDpi;
WORD g_SWWidth;			// pixel
WORD g_SWHeight;		// pixel
WORD g_wPixelDistance;  //even & odd sensor problem
WORD g_wLineDistance;
//WORD g_wLeftSide;
//WORD g_wTopSide;
WORD g_wScanLinesPerBlock;
WORD g_wReadedLines;
WORD g_wReadImageLines;
WORD g_wReadyShadingLine; 
WORD g_wStartShadingLinePos; 
WORD g_wLineartThreshold;

DWORD g_wtheReadyLines;
DWORD g_wMaxScanLines;
DWORD g_dwScannedTotalLines;
DWORD g_dwImageBufferSize;
DWORD g_BytesPerRow;
DWORD g_SWBytesPerRow;
DWORD g_dwCalibrationSize;
DWORD g_dwBufferSize;

DWORD g_dwTotalTotalXferLines;

unsigned short * g_pGammaTable;	//=NULL;
char* g_pDeviceFile;			//=NULL;

pthread_t g_threadid_readimage;

//user define type
COLORMODE	g_ScanMode;
TARGETIMAGE g_tiTarget;
SCANTYPE	g_ScanType = ST_Reflective;
SCANSOURCE	g_ssScanSource;	// = SS_Reflective;
PIXELFLAVOR g_PixelFlavor;	// = PF_BlackIs0;

//struct
SUGGESTSETTING g_ssSuggest;
Asic g_chip;

#endif /* end of the file spicall_g.h */


